#!/usr/bin/env python
# -*- coding: utf-8 -*-

import math, re, string, ConfigParser, os, decimal
import variable
from cgi import escape

import pdb
#pdb.set_trace()

#~ global DicoCalculs, DicoVariables, idCalc
#~ DicoCalculs = []
#~ DicoVariables = {}
#~ idCalc = 1

#*** Traitement des cellules ***************************************************
class traiter:
    '''Classe qui s\'occupe de traiter le contenu de cellules (formatage pour l'affichage, formatatage pour le stockage, ,recharge des variables et calculation du resultat)'''

    def __init__(self):
        #~ global BDDcalculs

        #init var
        self.entry = str    #definition
        self.signal = str   #def
        self.on_edit = None #def bool
        self.id = 0         #def int

        self.simpleOpperator = ('/','+','-','*','^')
        self.case0exposant =  (u'\xc2')

        self.optionAff = (1,1,0)

        self.listVarTmp = {}

        self.rowRef = {} #dico contenant idCalc : rowRef (rowRef est la réf de la ligne de calc)

        self.dicoCalc= []

        self.config = ConfigParser.ConfigParser()
        self.config.read(os.path.join(os.environ['NOTECALC_DIR'],'config.ini'))
        self.signe = eval(self.config.get('global','opperator')) #signe 'opperator (cad qui ne seront pas interpetter comme des varaiblemais comme des "signe mathématique"

        self.classVariable = variable.variable(self.config)

        self.unit='[]'


    def new(self,entry,id=None,var4calc=[],pressEntry=False):
        '''Lors d'une nouvelle saisie démarre tout le bastring'''
        #~ if pressEntry: pdb.set_trace()
        print '*** Fonction traiter.new ***'
        print pressEntry
        if pressEntry:
            print 'Lancer via le touche enter'
        self.entry = entry
        self.result = ''
        self.signal = None
        self.var4calc = var4calc
        del var4calc


        #Decoupage des ligne en liste, traitement individuelle de ces lignes
        newEntry = []
        comm = []
        for ligne in entry.splitlines():
            try :
                (calc, comment) = ligne.split('//',1) #Suppression commentaire de fin
            except :
                calc = ligne
                comment = ''

            newEntry.append(calc)
            comm.append(comment)
        newEntry  = "\n".join(newEntry)
        self.comm = "\n".join(comm)

        self.renderEntry = newEntry     #chaine qui sera utilisé par le moteur de rendu

        entry4findegal = []
        for partEntry in "".join(newEntry).split('*/'):
            if '/*' in partEntry:
                entry4findegal.append(partEntry.split('/*')[0])
            else :
                entry4findegal.append(partEntry)

        form = re.split('=',"".join(entry4findegal))   # éclate la chaine "newEntry" grâce au "="
        LenForm = len(form)

        self.nameVar = None
        self.unit = '[]'

        if LenForm == 1 :
            '''0 "=" trouvé --> simple opération'''
            if pressEntry :
                self.typeEntry = 'calc'
            self.result = self.calculer(newEntry)
            self.name = '$'

        elif LenForm == 2 :
            '''1 signe "=" trouvé -->'''
            #~ form[0] = self.supprComm(form[0])
            if self.isUnit(form[1]):
                '''Précision de l'untié de réslutat'''
                if pressEntry:
                    self.renderEntry = form[0]
                    self.typeEntry = 'calc'
                self.entry = form[0]
                self.result = self.calculer(form[0])
                self.unit = form[1]
            elif self.isVar(form[0]):
                '''C'est une variable'''
                print 'c\'est une variable'
                if pressEntry:
                    self.nameVar = form[0].strip()
                    self.classVariable.write(self.nameVar,id)
                    self.name = (form[0])
                    if self.isnum(form[1]) :
                        self.typeEntry = 'var'
                    else :
                        self.typeEntry = 'calcvar'

                self.result = self.calculer(form[1])

            elif form[1] == '':
                if pressEntry:
                    self.renderEntry = form[0]
                    self.typeEntry = 'calc'
                self.name = '$'
                self.result = self.calculer(form[0])

            else:
                self.result = _('Erreur')
                self.signal = 'Type inconnu si votre formule vous semble correct merci de me signaler le problème par Email (en précissant la formule entrée)'

        elif LenForm == 3 :
            print 'deux "=" trouvé'
            if self.isVar(form[0]) & self.isUnit(form[2]):
                if pressEntry:
                    if self.isnum(form[1]):
                        self.renderEntry = ''.join((form[0],'='))
                        slef.typeEntry = 'var'
                    else:
                        self.renderEntry = '='.join((form[0],form[1]))
                        self.typeEntry = 'calcvar'
                self.nameVar = form[0].strip()
                self.result = self.calculer(form[1])
                self.unit = form[2]
            else:
                self.result = 'Erreur'
                #~ self.unit = ''
                self.signal = 'Type inconnu si votre formule vous semble correct merci de me signaler le problème par Email (en précissant la formule entrée)'

        if pressEntry:
            self.classVariable.write('$'+str(id),id)

    def aff(self):
        '''option d'affichage (entier)'''
        self.aff
        return self.aff

    def get_nameVar(self):
        '''Retourne le nom de la variable'''
        if self.nameVar != None :
            return self.nameVar
        else :
            return ''

    def render(self,aff=(1,1,0)):
        '''Moteur de rendu (char)'''
        char = escape(self.renderEntry) #escape "echape" les syntaxe pango

        def formatComment(text):
            #~ pdb.set_trace()
            partText = []
            for ligne in text.splitlines():
                try :
                    ligne = ligne.split('//')[0]   #suppression commentaire fin
                except :
                    pass

                try :
                    if ligne[0] == '!' :#formatage d'un titre
                        if   (ligne[:6] == '!!!!!!'):
                            partText.append(ligne[6:].join((self.config.get('render','open_h6'),self.config.get('render','close_h6'))))
                        elif (ligne[:5] == '!!!!!'):
                            partText.append(ligne[5:].join((self.config.get('render','open_h5'),self.config.get('render','close_h5'))))
                        elif (ligne[:4] == '!!!!'):
                            partText.append(ligne[4:].join((self.config.get('render','open_h4'),self.config.get('render','close_h4'))))
                        elif (ligne[:3] == '!!!'):
                            partText.append(ligne[3:].join((self.config.get('render','open_h3'),self.config.get('render','close_h3'))))
                        elif (ligne[:2] == '!!'):
                            partText.append(ligne[2:].join((self.config.get('render','open_h2'),self.config.get('render','close_h2'))))
                        else : #(ligne[:1] == '!'):
                            partText.append(ligne[1:].join((self.config.get('render','open_h1'),self.config.get('render','close_h1'))))
                    else :
                        partText.append(ligne)
                except :
                    partText.append(ligne)

            newText = '\n'.join(partText)
            newText = newText.replace('/*',self.config.get('render','open_comment'))
            newText = newText.replace('*/',self.config.get('render','close_comment'))
            newText = newText.replace('[' ,self.config.get('render','open_unit'))
            newText = newText.replace(']' ,self.config.get('render','close_unit'))
            return newText
        def affArytm(char):
            return formatComment(char)
        def affNum(char):
            def rsortByNbLetter(a, b) :
                '''trie inverse selon le nombre de caractère (pour éviter des remplacements de "a" dans "ab"'''
                if len(a[0])<len(b[0]):   return 1
                else :              return -1
            char = formatComment(char)
            #~ pdb.set_trace()
            self.var4calc.sort(rsortByNbLetter)
            for (name,value,prec) in self.var4calc:
                #position du remplacement
                pos = char.find(name)
                nbltre = len(name)

                #formatge arrondi de la valeur
                str4print = '%s'%str4printRoundRes(prec)
                value = str4print%value

                while pos != -1 :
                    #~ pdb.set_trace()
                    if pos > 1:
                        if char[pos-1].isdigit() :
                            ''' mettre un signe "*" quand aritmétique 2a'''
                            char = "*%s"%value.join((char[0:pos],char[pos+nbltre:]))
                            #~ char = char.replace(name,"*%s"%str(value))
                        elif (char[pos-1].isspace() & char[pos-2].isdigit()) :
                            ''' mettre un signe "* " quand aritmétique 2 a'''
                            char = "* %s"%value.join((char[0:pos],char[pos+nbltre:]))
                        else :
                            char = str(value).join((char[0:pos],char[pos+nbltre:]))
                            #~ char = char.replace(name,"* %s"%str(value))
                    else :
                        char = str(value).join((char[0:pos],char[pos+nbltre:]))
                    pos = char.find(name)
                        #~ char = char.replace(name,str(value))
                #signe de multiplication quand on a
            return char
        def affLaTex(char):
            pass


        #char = convCaract(char)

        (algebre,num,latex) = aff

        renderAlgebre = renderNum = False

        if algebre:
            renderAlgebre = affArytm(char)
        if num and self.typeEntry != 'txt' :
            renderNum = affNum(char)

        if not renderAlgebre and self.typeEntry != 'txt':
            char = renderNum
        elif not renderNum :
            char = renderAlgebre
        elif renderAlgebre == renderNum :
            char = renderAlgebre
        else:
            char = '\n'.join((renderAlgebre,renderNum))

        #transphomation de certain élément pour un meilleur rendu pengo
        #~ pdb.set_trace()
        reBrute2Pengo = [
                #~ (r'_{([\S\s][^}]*)]}'     , '<sub>%(0)s</sub>'), # indice
                (r'_([\S]*[^\s+-/\*=]*)'   , '<sub>%(0)s</sub>'), # indice
                #~ (r'\^{([\S\s][^}]*)]}'    , '<sup>%(0)s</sup>'), # exposant
                (r'\^([\S]*[^\s+-/\*=]*)'  , '<sup>%(0)s</sup>')  # exposant
            ]

        for (brute,pengo) in reBrute2Pengo :
            brutenc = brute #chaîne non compilée
            brute = re.compile(brute)
            while brute.search(char) :
                groups = brute.search(char).groups()
                dico_s = {}
                i = 0
                #pdb.set_trace()
                for s in groups :
                    dico_s[str(i)] = s
                    i += 1
                remplace = pengo %dico_s
                char = re.sub(brute,remplace,char,1)


        if latex:
            pass

        return char


    def precRes(self):
        '''Précision de l'unitée (entier)'''
        self.precRes
        return self.precRes

    #~ def str4printRoundRes(self,prec=None) :
        #~ '''Chaine pour le rendu avec le bon nombre de chiffre après la virgule'''
        #~ if (prec == None) :
            #~ prec = self.precRes
#~
        #~ if prec < 0:
            #~ 'precision négative = arrondi au multiple 10**x'
            #~ res = round(res*10**prec)*10**(-prec)
            #~ prec = 0
        #~ return '%%.%if'%prec


    def resultat(self):
        '''Resultat (double)'''
        self.result
        return self.result

    def get_unit(self):
        '''Unitée (str)'''
        def autoUnit(self):
            '''A partir d'un tableau trouve l'unitée automatiquement'''
            return ''
        #~ if not self.unit:
            #~ autoUnit(self.unit)
        '''Unitee du resultat (str)'''
        return self.unit.strip()[1:-1]

    def get_type(self):
        '''retoune le type de la ligne
        (calc, txt, var, calcvar, txt, h1 ...)'''
        return self.typeEntry

    def listVar(self):
        return ''

    def get_commentaire(self):
        return self.comm

    def cdmConfirm(self,id,char):
        '''
        Fonction lancé lors de la confirmation de la zone de saisie cmd.
        Elle lance :
        - Le moteur de rendu des formules
        - Calcul la forule
        - envoi le tout dans le DicoCalculs
        - retourn une liste prète a etre affichée des la treeview listDeCalc
        '''
        #pdb.set_trace()
        self.dicoCalc.insert(id,{
            'entry' : char,      #La chaine entrée par l'utilisateur
            'aff'   : self.optionAff,   #Les options d'affichage
            'render': self.render(char),
            'comment':self.searchExtComment(char),
            #'histo' : self.dicoCalc[id]['histo'].append(rendu),
            'var'   : self.listVarTmp
        })

        return(
            id,
            self.dicoCalc[id-1]['render'],    #formule passée pas le moteur de rendu
            "self.dicoVar['$'][id]",          #resultat(val,unit,prec)
            self.dicoCalc[id-1]['comment']    #commentaire
        )

    def searchExtComment(self,char):
        deb = char.find('//')
        if deb != -1:
            return char[deb+2:]
        else:
            return ""



    def optionAffichage(self,entier):
        self.optionAff += entier
        print "Option d'affichage à %s" %self.optionAff



    def start(self,id,s):

        self.ENTRYxml = {}  #dico qui sera envoyer dans le fichier xml : {'nom','entree_brute','rendu','resultat'}
        self.ENTRYxml = {'entree_brute':s}   #enregistrement du texte "brut"
        self.ENTRYxml = {'rendu':self.rendu(s)}  #Format le texte pour le rendu

        form = re.split('=',s)   # éclate la chaine "char" grâce au "="
        LenForm = len(form)

        if LenForm == 1 :
            '''0 signe "=" trouvé --> simple opération'''
            self.ENTRYxml['resultat'] = self.calculer(s)
        elif LenForm == 2 :
            '1 signe "=" trouvé -->'
            if self.isVar(form[0]):
                print 'c\'est une variable'
                self.ENTRYxml['resultat'] = self.calculer(form[1])
                self.classVariable.write(form[0],self.ENTRYxml['resultat'])
            elif form[1] == '':
                self.ENTRYxml['resultat'] = self.calculer(form[0])
            elif self.isUnit(form[1]):
                self.ENTRYxml = {
                    'resultat' : self.calculer(form[0]),
                    'unitee' : self.calculer(form[1])
                }
            else:
                print 'type inconnu in "traiter.start"'
        elif LenForm == 3 :
            print 'deux "=" trouvé'
            if self.isVar(form[0]) & self.isUnit(form[2]):
                self.ENTRYxml = {
                    'resultat' : self.calculer(form[1]),
                    'unitee' : self.calculer(form[2])
                }


        return self.ENTRYxml


    def isVar(self,s):                  #Regarde si c'est une variable
        #pdb.set_trace()
        for signe in self.signe:
            if s.find(signe) == -1:
                return True
        if re.search(self.signe,s):
            return None
        else:
            return 1

    def isnum (self,char):                 #regarde si c'est en nombre
        for s in char :
            if (not s.isdigit()) & (s != '.') :
                return False
        return True

    def isCalc(self,s):                 #Regarde si c'est un calcul
        pass

    def isUnit(self,s):
        '''S'agit t-il d'un unitée ?'''
        s = s.strip()
        if s.startswith('[') & s.endswith(']'):
            return 1
        else:
            return None


    def calculer(self,s):
        '''*** FONCTION TRAITEMENT.CALCUL ***'''

        def human2python(calc):
            '''Convertir les ponctations d'oppération "humain" en oppération python
            char4eval est un liste des chiffre et oppérateur (['22','+','2'])'''

            nbItem = len(calc)
            id = 0
            newcalc = []

            #unitée de angle par defauf
            if self.config.get('angles','unit') == 'deg':
                convAngle = '(math.pi/180)'
            elif self.config.get('angles','unit') == 'grad':
                convAngle = '(math.pi/200)'
            else:
                convAngle = '1'

            tmpcalc = []

            #remplacement des opération simplement remplacable pour que python les commprennent
            operatorSimpleReplace = {}
            # 1) chargement a partir du fichier de config
            for item in self.config.options('simpleOpperatorReplace'):
                operatorSimpleReplace[item] = self.config.get('simpleOpperatorReplace',item)

            for item in calc:
                if item in operatorSimpleReplace:
                    tmpcalc.append(operatorSimpleReplace[item])

            while id < nbItem:
                #~ print "%s < %s => %s"%(id,nbItem,calc[id])
                if calc[id].isdigit() :
                    '''convertir les int en floats (en ajoutant un "." a la chaine'''
                    newcalc.append('.'.join((calc[id],'0')))
                elif calc[id] in ('+','-','*','/','(',')','**'):
                    '''Signe directement reconnu par python'''
                    newcalc.append(calc[id])
                elif calc[id] in ('sin','cos','tan','asin','atan','acos'):
                    '''Trigo : si non suivi d'une parenthèse, l'ajouter.
                    Convertit l'angle en radian)'''
                    #newcalc.extend(('math.',calc[id]))
                    if calc[id] == '(':
                        newcalc.append('(')
                        parenthese = 1
                        newcalctmp = []
                        while not par == 0: #trouvé la parentèse de fermeture
                            id += 1
                            newcalctmp.append(calc[id])
                            if calc[id] == '(': parenthese += 1
                            elif calc[id] == ')': parenthese -= 1
                        newcalc.extend(('math.',calc[id],'('))
                        newcalc.extend(human2python(newcalctmp))
                        if calc[id] in ('sin','cos','tan'):
                            newcalc.extend(('*',convAngle,')'))
                        else: #(asin, acos, atan)
                            newcalc.extend((')/',convAngle))
                    else:
                        #pdb.set_trace()
                        if id < nbItem:
                            #pdb.set_trace()
                            if calc[id] in ('sin','cos','tan'):
                                newcalc.extend(('math.',calc[id],'(',(calc[id+1]),'*',convAngle,')'))
                            else: #(asin, acos, atan)
                                newcalc.extend(('math.',calc[id],'(',(calc[id+1]),')/',convAngle))
                        id += 1
                elif calc[id] in operatorSimpleReplace:
                    '''signe demandant un simple remplacement'''
                    newcalc.append(operatorSimpleReplace[calc[id]])
                else:
                    newcalc.append(calc[id])
                id += 1
                #~ print "remplacer par %s"%newcalc[-1]

            return newcalc


        s = ''.join(s.split())  #suppression espace blanc
        s = self.supprComm(s)   # Enlève les commentaires

        if s == '' :
            '''simple commentaire ou titre, aucun calculs à faire'''
            return 0.


        #~ dicoVar = self.findVar(s)   # Cette fonction ajoute/modifie la variable global self.char4eval qui servira par la suite

        self.get_namesVars(s,True)
        var = {}
        #~ pdb.set_trace()
        for (name,value,prec) in self.var4calc: #liste les variables dans un dico
            var[name] = value
            print "var[%s] = %s" %(name,value)

        #~ pdb.set_trace()
        self.char4eval = human2python(self.char4eval) #Convertir les ponctation d'oppération "humain" en oppération python
        print 'Valeur des varaible pour le calcul : %s'%self.var4calc
        print 'chaine à évaluer : %s'%self.char4eval
        #~ pdb.set_trace()
        try :
            return eval(''.join(self.char4eval))
        except :
            self.typeEntry = 'txt'
            return False


    def supprComm (self,s):
        'Suppression des commentaires et titre'
        #~ pdb.set_trace()
        if s == '' :
            self.typeEntry = 'txt'
            return ''
        if s[0] == '!' :
            try :
                if   (s[:6] == '!!!!!!'):   self.typeEntry = 'h6'
                elif (s[:5] == '!!!!!'):    self.typeEntry = 'h5'
                elif (s[:4] == '!!!!'):     self.typeEntry = 'h4'
                elif (s[:3] == '!!!'):      self.typeEntry = 'h3'
                elif (s[:2] == '!!'):       self.typeEntry = 'h2'
                elif (s[:1] == '!'):        self.typeEntry = 'h1'
                return ''
            except :
                pass
        deb = s.find('//')  #Commantaire de fin
        if deb != -1:
            s = s[0:deb]
        deb = s.find('/*')  #Commentaire au centre
        while deb != -1:
            '''Commentaire'''
            #~ pdb.set_trace()
            fin = s.index ('*/')
            if fin != -1:
                s = s[0:deb] + s[fin+2:]
            else:
                break
            deb = s.find('/*')
        deb = s.find('[')
        while deb != -1:    #Unitée
            '''Unitée'''
            fin = s.index (']')
            if fin != -1:
                s = s[0:deb] + s[fin+1:]
            else:
                break
            deb = s.find('[')


        if s.strip() == '' :    #Si apres avoir supprimer les commentaire et les calcul il ne reste rien c'est du texte seul
            self.typeEntry = 'txt'

        return s


    #~ def unitee (self,s):
        #~ 'Trouve les unités, ajoute un facteur multiplicatif et retourne la chaine avec facteur et sans unitée'
#~
        #~ s = re.sub('\[tonne\]','*1000000',s)
        #~ s = re.sub('\[k.','*1000',s)
        #~ s = re.sub('\[h.','*100',s)
        #~ s = re.sub('\[da.','*10',s)
        #~ s = re.sub('\[.','*1',s)
        #~ s = re.sub('\[d.','/10',s)
        #~ s = re.sub('\[c.','/100',s)
        #~ s = re.sub('\[m.','/1000',s)
        #~ s = re.sub(']','',s)
        #~ return s

    def rendu(self,s):
        # Commentaire en italique
        deb = s.find('//')
        if deb != -1:
            return s[0:deb] + '<i>' + s[deb+2:] + '</i>'
        deb = s.find('/*')
        while deb != -1:
            fin = s.index ('*/')
            if fin:
                return s[0:deb] + '<i>' + s[deb+2:fin] + '</i>' + s[fin+2:]
            else:
                break
            #deb = s.find('/*')


    def afficherVariable(self,char):
        '''Recherche de la liste des valeurs d'une variable'''
        print "*** Fonction traiter.afficherVariable ***"
        #Recherche du nom de la dernière variable
        (nameVar,i) = self.classVariable.nameVarInEndChar(char)
        #Recherche des valeurs de la variable
        if nameVar:
            valueVar = self.classVariable.read(nameVar)
        else:
            valueVar = None
        #Retourne une liste contenant les valeurs de la variable (ou none si elle n'existe pas)
        return (nameVar,valueVar)


    def get_namesVars(self, str, makeChar4eval = False):
        '''retourne la liste des varaibles présente dans la chaine.'''
        #récupération de la partie équations
        form = re.split('=',str)
        LenForm = len(form)
        if LenForm == 1 :
            str4findVar = form[0]
        elif LenForm == 2 :
            if self.isUnit(form[1]) :
                str4findVar = form[0]
            else:
                str4findVar = form[1]
        elif  LenForm == 3 :
            str4findVar = form[1]

        str4findVar = self.supprComm(str4findVar)

        varASstart = False      # est ce qu'une variable a débuter (commence par une lettre)
        listVar = []            # liste des varaible (nom)
        if makeChar4eval :
            self.char4eval = []
        partChar4eval = []
        varName = ''            # nom de la variable courante
        varNameConstruct = []   # construction nom variable
        numberConstruct = []    # construction nombre
        #~ pdb.set_trace()
        prevType = ''
        for c in str4findVar + ' ' :
            #~ if c is 'e' : pdb.set_trace()
            if varASstart: #On se trouve dans un variable. les lettres et chiffre sont alors accetper
                #~ try :
                    #~ c.isspace()
                    #~ c in self.simpleOpperator
                    #~ c in self.case0exposant
                #~ except :
                    #~ pdb.set_trace()
                if (not c.isspace()) & (not c in self.simpleOpperator) & (not c in self.case0exposant):
                    '''Compète list des lettre de la variable'''
                    varNameConstruct.append(c)
                else:
                    '''Assemble les lettres de la variable'''
                    varName = ''.join(varNameConstruct)
                    print varName
                    if (not varName in listVar) & (not varName in self.signe) :
                        '''Si la variable ne se trouve pas encore dans la liste des variables
                        est que ce n'est pas le nom d'un opérateur : l'ajoute à la liste'''
                        listVar.append(varName)
                    if (makeChar4eval) :
                        '''Construit la liste pour l'évaluation du calculs'''
                        if varName in self.signe :
                            '''Signe d'operation, a ajouter simplement'''
                            self.char4eval.append(varName)
                            prevType = 'opperator'
                        elif prevType == 'number' :
                            '''Le type précédent est un nombre, ajout d'un signe "*" avant de mettre la\
                            varaible sous la forme var['%s']'''
                            self.char4eval.extend(('*',"var['%s']"%varName))
                            prevType = 'variable'
                        else :
                            '''Ajout de la variable sous a forme var['%s']'''
                            self.char4eval.append("var['%s']"%varName)
                            prevType = 'variable'

                        if c in self.simpleOpperator :
                            '''Si le caractère en cours est un opérateur simple, l'ajoute et vide "varNameConstruct"'''
                            self.char4eval.append(c)
                            prevType = 'operator'

                    if c in self.case0exposant :
                        '''spécial exposant ² et ³ sur 2 case, commence "varNameConstruct" avec cette \xc2'''
                        varNameConstruct = [c]
                    else :
                        varNameConstruct = []

                    varASstart = False
            elif (c.isdigit()) :
                numberConstruct.append(c)
            elif (c == '.') :
                numberConstruct.append(c)
            elif (not c.isdigit()) & (not c.isspace()) & (not c in self.simpleOpperator):
                '''Une lettre trouvée début de la variable'''
                if makeChar4eval & (numberConstruct != []) :
                    '''ajout du nombre qui précède la lettre (sans signe séparateur)'''
                    self.char4eval.append(''.join(numberConstruct))
                    numberConstruct = []
                    prevType = 'number'
                #indique que la construction d'un nom a commancée
                varNameConstruct.append(c)
                varASstart = True
                #~ print 'start'
                if makeChar4eval & (partChar4eval != []) :
                    self.char4eval.append(''.join(partChar4eval))
                    prevType = 'unknown'
            elif makeChar4eval :
                #~ pdb.set_trace()
                if numberConstruct != [] :
                    self.char4eval.append(''.join(numberConstruct))
                    numberConstruct = []
                    prevType = 'number'
                if not c.isspace() :
                    self.char4eval.append(c)
                    prevType = 'unknown'


        #pdb.set_trace()
        return listVar #liste du nom des variables

    def get_char4eval(self) :
        return self.char4eval


    def findVar(self,char):
        '''Ancinenne fonction remplacer par get_namesVars ??? Prend un chaine et retourne un dico des variable sous la forme {nameVar1:(valueVar,debut,fin), nameVar2:...}'''
        print '*** traiter.py : findVar ***'
        truc = machin_pour_faire_erreur
        dicoVar = {}
#        (nameVar,debut) = self.classVariable.nameVarInEndChar(char)
        #print self.classVariable.findVars(char)
        #~ pdb.set_trace()


        form = re.split('=',char)
        LenForm = len(form)

        if LenForm == 1 :
            char4findVar = form[0]
        elif LenForm == 2 :
            if self.isUnit(form[1]) :
                char4findVar = form[0]
            else:
                char4findVar = form[1]
        elif  LenForm == 3 :
            char4findVar = form[1]

        (self.char4eval,var4calc) = self.classVariable.findVars(self.supprComm(char4findVar))

        for (nameVar,deb,fin) in var4calc:
            #pdb.set_trace()
            if nameVar in self.listVarTmp:
                valueVar = self.listVarTmp[nameVar]
            else:
                valueVar = self.classVariable.read(nameVar)

            #dicoVar[nameVar] = (valueVar,deb,len(char)) # envoie dans le dicovar le valeur de la variable, posDeb et pos Fin
            dicoVar[nameVar] = valueVar

            char = char[:deb]

            print "newwwwwwwwwwwwwwww char : %s" %char
            (nameVar,deb) = self.classVariable.nameVarInEndChar(char)

        print "dico de variable utile :"
        print dicoVar
        return dicoVar

    def findOpperator(self,char):
        '''Prend un chaine et retourne une liste d'instance match'''
        #for match in re.finditer('\*|\+',char):
        #   print match.groupe(0),match.start(0),match.endswith(0)
        return

    def finditerAll(self,char):
        '''Prend une chaine et trouve des listes :
        - des valeurs numérique (valeur,deb,fin)
        - des variables (nom,deb,fin)
        - des opérateurs (opp,deb,fin)'''
        self.finditerNum = ()
        self.finditerVar = ()
        self.finditerOpp = ()

        #for ligne in re.finditer('\*|\+|\/|\-',char):
        #    self.finditerOpp.append(

    def char2form(self,char):
        pass

    def type(self,char):
        '''si "= [*]se trouve à la fin (unitée) alors on ajoute "[*] après le resultat'''
        '''suprimmer le "=" si il se trouve à la fin'''
        form = re.split('=',char)
        LenForm = len(form)
        print 'la chaine %s contient %s "="' % (char, LenForm-1)
        print form
        print 'opérateur : %s .' % self.operateur

        print "la chaine %s est de type :" % char
        #if re.match(self.commentateur,form[0]):#ne DEVRAIT que regarder le 1er caractère pour le commentateur
        if 1 == 2:
            print "texte"
            cellres = ''
        elif LenForm == 1:
            if re.search(self.operateur, form[0]):
                print "calcul"
                cellres = self.calcul(form[0])
            else:
                print "variable"
                cellres = 'va chercher la variable dans la BDD'
        elif LenForm == 2:
            #variable = calcule
        #elfi <> comparaison
            print "la chaine %s est de type calcul" % char
            cellres = self.calcul(form[0])
        #elif
        return  cellres



def str4printRoundRes(prec) :
    '''Chaine pour le rendu avec le bon nombre de chiffre après la virgule'''
    if prec < 0:
        'precision négative = arrondi au multiple 10**x'
        res = round(res*10**prec)*10**(-prec)
        prec = 0
    return '%%.%if'%prec



if __name__ == '__main__':
    import notecalc
    #~ exit()
    traiter = traiter()
    print "listVar   : %s"%traiter.get_namesVars("a + a²",True)
    print "char4aval : %s"%traiter.get_char4eval()
    #~ print traiter.new("2²")
